#!/bin/sh

CMD=evince
#CMD=xpdf
DELAY=0.5
EXT=pdf
BASENAME=DanstedThesis06
COPIES="$1"
CYCLES=3
MINMEM=29999 #Minimum amount of remaining memory in KB
SWAPDIVIDER=2

checkexist() {
	echo checking if $1 exists
	while ! wmctrl -l > checkexist.tmp
	do
		echo COULD NOT RUN WMCTRL -l
	done
	grep "$1" < checkexist.tmp
}

openfile () {
	$CMD $1 &
	while ! checkexist "$1"
	do
		echo "$1" not yet open
		sleep $DELAY
	done
}

closefile () {
	while checkexist "$1" #wmctrl -R "$1"
	do
		wmctrl -c "$1"
		sleep $DELAY
	done
}

checkmem() { 
rm -f meminfo
cp /proc/meminfo .
Cached=`grep ^Cached: < meminfo | sed s/[^0-9]//g`
SwapFree=`grep ^SwapFree: < meminfo | sed s/[^0-9]//g`
Free=`grep ^Free: < meminfo | sed s/[^0-9]//g`
AvailMem=$(($Cached+($SwapFree/$SWAPDIVIDER)+$Free))
#also check Buffers?
echo Cached: $Cached KB
echo SwapFree: $SwapFree KB
echo Free: $Free KB
echo AvailMem: $AvailMem KB

if [ $AvailMem -lt $MINMEM ]
then
	echo AvailMem has dropped below $MINMEM, aborting
	exit 1
fi
}
	

copy=1
while [ $copy -le $COPIES ]
do
	cp $BASENAME.$EXT $BASENAME.$copy.$EXT
	echo cp $BASENAME.$EXT $BASENAME.$copy.$EXT
	copy=$(($copy+1))
	
done
c=1
while [ $c -le $CYCLES ]
do
	echo CYCLE $c
	copy=1
	while [ $copy -le $COPIES ]
	do
		echo $c $copy
		closefile $BASENAME.$copy.$EXT
		openfile $BASENAME.$copy.$EXT
		copy=$(($copy+1))
		checkmem
	done
	c=$(($c+1))

done

cat /proc/meminfo

copy=1
while [ $copy -le $COPIES ]
do
	closefile $BASENAME.$copy.$EXT
	copy=$(($copy+1))
done
